package com.tzld.piaoquan.ad.engine.commons.base;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.validation.constraints.NotNull;

@Getter
@NoArgsConstructor
public class AdItemFeature {
    @Setter
    @NotNull
    private String adId = "0";

    @Setter
    @NotNull
    private String adCode = "0";

    @Setter
    @NotNull
    private String advertiserId = "0";
    @Setter
    @NotNull
    private String advertiserCode = "0";

    @Setter
    @NotNull
    private String campaignId = "0";

    @Setter
    @NotNull
    private String campaignCode = "0";

    @Setter
    @NotNull
    private String creativeId = "0";

    @Setter
    @NotNull
    private String creativeCode = "0";



    // 当天统计量信息
    private AdActionFeature day1_cnt_features;
    // 3天内统计量
    private AdActionFeature day3_cnt_features;
    // 7天内统计量
    private AdActionFeature day7_cnt_features;
    // 3个月统计量
    private AdActionFeature month3_cnt_features;



    public void setAdId(String key){
        if(key == null){
            this.adId = "0";
        } else {
            this.adId = key;
        }
    }


    public void setAdvertiserId(String key){
        if(key == null){
            this.advertiserId = "0";
        } else {
            this.advertiserId = key;
        }
    }

    public void setCampaignId(String key){
        if(key == null){
            this.campaignId = "0";
        } else {
            this.campaignId = key;
        }
    }


    public void setCreativeId(String key){
        if(key == null){
            this.creativeId = "0";
        } else {
            this.creativeId = key;
        }
    }



    public void setDay1_cnt_features(AdActionFeature feature) {
        this.day1_cnt_features = feature;
    }


    public void setDay3_cnt_features(AdActionFeature feature) {
        this.day3_cnt_features = feature;

    }

    public void setDay7_cnt_features(AdActionFeature feature) {
        this.day7_cnt_features = feature;

    }

    public void setMonth3_cnt_features(AdActionFeature feature) {
        this.month3_cnt_features = feature;

    }

    public String getKey() {
        return this.adId;
    }

    public String getValue() {
        Gson gson = new GsonBuilder().serializeSpecialFloatingPointValues().create();
        return gson.toJson(this);
    }


}
