package com.tzld.piaoquan.ad.engine.service.score.convert;

import com.tzld.piaoquan.ad.engine.commons.base.AdActionFeature;
import com.tzld.piaoquan.ad.engine.commons.base.AdItemFeature;
import com.tzld.piaoquan.ad.engine.commons.base.UserAdFeature;
import com.tzld.piaoquan.recommend.feature.model.feature.*;

/**
 * @author dyp
 */
public class FeatureConvert {

    public static UserAdFeatureProto convertToProto(UserAdFeature userAdFeature) {
        UserAdFeatureProto.Builder builder = UserAdFeatureProto.newBuilder();
        builder.setMid(userAdFeature.getMid());
        builder.setGender(userAdFeature.getGender());
        builder.setUserType(userAdFeature.getUser_type());
        builder.setGmtCreate(userAdFeature.getGmt_create());
        builder.setTags(userAdFeature.getTags());
        builder.setCategoryName(userAdFeature.getCategory_name());
        builder.setIsvip(userAdFeature.getIsvip());
        builder.setIsreward(userAdFeature.getIsreward());
        builder.setIsad(userAdFeature.getIsad());
        builder.setIsgood(userAdFeature.getIsgood());
        builder.setFirstUpDatetime(userAdFeature.getFirst_up_datetime());
        builder.setLastUpDatetime(userAdFeature.getLast_up_datetime());
        builder.setNextToLastUpDatetime(userAdFeature.getNext_to_last_up_datetime());
        builder.setVideos(userAdFeature.getVideos());
        builder.setIdols(userAdFeature.getIdols());
        builder.setFans(userAdFeature.getFans());
        builder.setPlayCount(userAdFeature.getPlay_count());
        builder.setPlayCountTotal(userAdFeature.getPlay_count_total());
        builder.setTotalReward(userAdFeature.getTotal_reward());
        builder.setCurrentdayReward(userAdFeature.getCurrentday_reward());
        builder.setRewardPerson(userAdFeature.getReward_person());
        builder.setTotalRewardTimes(userAdFeature.getTotal_reward_times());
        builder.setRewardVideos(userAdFeature.getReward_videos());
        builder.setTotalPrice(userAdFeature.getTotal_price());
        builder.setCurrentdayPrice(userAdFeature.getCurrentday_price());
        builder.setTotalPriceTimes(userAdFeature.getTotal_price_times());
        builder.setTotalPricePerson(userAdFeature.getTotal_price_person());
        builder.setTotalPriceVideos(userAdFeature.getTotal_price_videos());
        builder.setCgrainUserType(userAdFeature.getCgrain_user_type());
        builder.setIdentityTagname(userAdFeature.getIdentity_tagname());
        builder.setOperationTags(userAdFeature.getOperation_tags());
        builder.setIdentityTagId(userAdFeature.getIdentity_tag_id());
        builder.setIdentityCreateTime(userAdFeature.getIdentity_create_time());
        builder.setCountry(userAdFeature.getCountry());
        builder.setProvince(userAdFeature.getProvince());
        builder.setCity(userAdFeature.getCity());

        builder.setDay1CntFeatures(convertToProto(userAdFeature.getDay1_cnt_features()));
        builder.setDay3CntFeatures(convertToProto(userAdFeature.getDay3_cnt_features()));
        builder.setDay7CntFeatures(convertToProto(userAdFeature.getDay7_cnt_features()));
        builder.setMonth3CntFeatures(convertToProto(userAdFeature.getMonth3_cnt_features()));

        return builder.build();
    }

    public static UserAdFeature convertToJava(UserAdFeatureProto userAdFeatureProto){
            UserAdFeature userAdFeature = new UserAdFeature();
            userAdFeature.setMid(userAdFeatureProto.getMid());
            userAdFeature.setGender(userAdFeatureProto.getGender());
            userAdFeature.setUser_type(userAdFeatureProto.getUserType());
            userAdFeature.setGmt_create(userAdFeatureProto.getGmtCreate());
            userAdFeature.setTags(userAdFeatureProto.getTags());
            userAdFeature.setCategory_name(userAdFeatureProto.getCategoryName());
            userAdFeature.setIsvip(userAdFeatureProto.getIsvip());
            userAdFeature.setIsreward(userAdFeatureProto.getIsreward());
            userAdFeature.setIsad(userAdFeatureProto.getIsad());
            userAdFeature.setIsgood(userAdFeatureProto.getIsgood());
            userAdFeature.setFirst_up_datetime(userAdFeatureProto.getFirstUpDatetime());
            userAdFeature.setLast_up_datetime(userAdFeatureProto.getLastUpDatetime());
            userAdFeature.setNext_to_last_up_datetime(userAdFeatureProto.getNextToLastUpDatetime());
            userAdFeature.setVideos(userAdFeatureProto.getVideos());
            userAdFeature.setIdols(userAdFeatureProto.getIdols());
            userAdFeature.setFans(userAdFeatureProto.getFans());
            userAdFeature.setPlay_count(userAdFeatureProto.getPlayCount());
            userAdFeature.setPlay_count_total(userAdFeatureProto.getPlayCountTotal());
            userAdFeature.setTotal_reward(userAdFeatureProto.getTotalReward());
            userAdFeature.setCurrentday_reward(userAdFeatureProto.getCurrentdayReward());
            userAdFeature.setReward_person(userAdFeatureProto.getRewardPerson());
            userAdFeature.setTotal_price_times(userAdFeatureProto.getTotalRewardTimes());
            userAdFeature.setReward_videos(userAdFeatureProto.getRewardVideos());
            userAdFeature.setTotal_price(userAdFeatureProto.getTotalPrice());
            userAdFeature.setCurrentday_price(userAdFeatureProto.getCurrentdayPrice());
            userAdFeature.setTotal_price_times(userAdFeatureProto.getTotalPriceTimes());
            userAdFeature.setTotal_price_person(userAdFeatureProto.getTotalPricePerson());
            userAdFeature.setTotal_price_videos(userAdFeatureProto.getTotalPriceVideos());
            userAdFeature.setCgrain_user_type(userAdFeatureProto.getCgrainUserType());
            userAdFeature.setIdentity_tagname(userAdFeatureProto.getIdentityTagname());
            userAdFeature.setOperation_tags(userAdFeatureProto.getOperationTags());
            userAdFeature.setIdentity_tag_id(userAdFeatureProto.getIdentityTagId());
            userAdFeature.setIdentity_create_time(userAdFeatureProto.getIdentityCreateTime());
            return userAdFeature;
    }

    public static AdActionFeatureProto convertToProto(AdActionFeature adActionFeature) {
        AdActionFeatureProto.Builder builder = AdActionFeatureProto.newBuilder();
        builder.setAdView(adActionFeature.getAdView());
        builder.setAdClick(adActionFeature.getAdClick());
        builder.setAdConversion(adActionFeature.getAdConversion());
        builder.setCtr(adActionFeature.getCtr());
        builder.setCvr(adActionFeature.getCvr());
        return builder.build();
    }
    public static AdActionFeature convertToJava(AdActionFeatureProto adActionFeatureProto) {
        AdActionFeature adActionFeature = new AdActionFeature();
        adActionFeature.setAdView(adActionFeatureProto.getAdView());
        adActionFeature.setAdClick(adActionFeatureProto.getAdClick());
        adActionFeature.setAdConversion(adActionFeatureProto.getAdConversion());
        adActionFeature.setCtr(adActionFeatureProto.getCtr());
        adActionFeature.setCvr(adActionFeatureProto.getCvr());
        return adActionFeature;
    }

    public static AdItemFeature convertToJava(AdItemFeatureProto adItemFeatureProto) {
        AdItemFeature adItemFeature = new AdItemFeature();
        adItemFeature.setAdId(adItemFeatureProto.getAdId());
        adItemFeature.setAdCode(adItemFeatureProto.getAdCode());
        adItemFeature.setAdvertiserId(adItemFeatureProto.getAdvertiserId());
        adItemFeature.setAdvertiserCode(adItemFeatureProto.getAdvertiserCode());
        adItemFeature.setCampaignId(adItemFeatureProto.getCampaignId());
        adItemFeature.setCampaignCode(adItemFeatureProto.getCampaignCode());
        adItemFeature.setCreativeId(adItemFeatureProto.getCreativeId());
        adItemFeature.setCreativeCode(adItemFeatureProto.getCreativeCode());
        return adItemFeature;
    }

    public static AdItemFeatureProto convertToProto(AdItemFeature adItemFeature) {
        AdItemFeatureProto.Builder builder = AdItemFeatureProto.newBuilder();
        builder.setAdId(adItemFeature.getAdId());
        builder.setAdCode(adItemFeature.getAdCode());
        builder.setAdvertiserId(adItemFeature.getAdvertiserId());
        builder.setAdvertiserCode(adItemFeature.getAdvertiserCode());
        builder.setCampaignId(adItemFeature.getCampaignId());
        builder.setCampaignCode(adItemFeature.getCampaignCode());
        builder.setCreativeId(adItemFeature.getCreativeId());
        builder.setCreativeCode(adItemFeature.getCreativeCode());
        builder.setDay1CntFeatures(convertToProto(adItemFeature.getDay1_cnt_features()));
        builder.setDay3CntFeatures(convertToProto(adItemFeature.getDay3_cnt_features()));
        builder.setDay7CntFeatures(convertToProto(adItemFeature.getDay7_cnt_features()));
        builder.setMonth3CntFeatures(convertToProto(adItemFeature.getMonth3_cnt_features()));
        return builder.build();
    }
}
